;
; This file is part of MIA.
;
; MIA is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIA; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; mtv.pro
; Created:     Mon May 26 11:14:50 2003 by Koehler@sun47
; Last change: Mon May 26 15:23:48 2003
;
; PURPOSE:
;	save the world
;
; CALLING SEQUENCE:
;	mtv, data [, atv-flags]
;
; INPUT:
;	data - one slice of MIDI data (a struct with elements data1
;              and data2)
;	atv-flags - all flags accepted by atv
;
; OUTPUT:
;	calls atv to display the frame data
;
PRO mtv, data, _EXTRA = extra
  data = data[0]	;just in case someone gave us an array

  sz1 = size(data.data1)
  sz2 = size(data.data2)
  sz_x= sz1[1] + 1 + sz2[1]

  tags = strtrim(tag_names(data),2)
  if where(tags eq "DATA3") ge 0 then begin
      ; there's a data3 field, so this is probably sci-phot data
      sz3 = size(data.data3)
      sz4 = size(data.data4)

      sz_x= max( [sz_x, sz3[1] + 1 + sz4[1]] )
      sz_y= max( [sz1[2]+1+sz3[2], sz2[2]+1+sz4[2]] )

      img = fltarr(sz_x,sz_y)
      img[     0  : sz1[1]-1, sz3[2]+1 : sz_y-1 ] = data.data1
      img[ sz1[1]+1 : sz_x-1, sz4[2]+1 : sz_y-1 ] = data.data2
      img[     0  : sz3[1]-1,     0  : sz3[2]-1 ] = data.data3
      img[ sz3[1]+1 : sz_x-1,     0  : sz4[2]-1 ] = data.data4

  endif else begin
      sz_y= max( [sz1[2],sz2[2]] )

      img = fltarr(sz_x,sz_y)
      img[   0 : sz1[1]-1 ,* ] = data.data1
      img[ sz1[1]+1:sz_x-1,* ] = data.data2
  endelse
  ;print,sz_x," x ",sz_y

  atv, img, _EXTRA=extra
end
