;
; This file is part of MIA.
;
; MIA is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIA; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
PRO makefringe,file,i1,i2,fringe,opd
data=oircompressdata(file,opd=opd,ierr=ierr)
if (ierr NE 0) then begin
   ewsprinterrmsg
   RETURN
endif
tags=tag_names(data)
tag1=WHERE(tags EQ 'DATA1')
fringe = data.(i1+tag1-1) - data.(i2+tag1-1)
fringe=fringe-mean(fringe)
opd=opd*1.e6
return
end

PRO tvsclm,a,b,c,d
if (N_PARAMS() LT 2) then b=1
s=size(a)
if (N_PARAMS() LT 3) then tvscl,rebin(a,b*s[1], b*s[2]) $
else tvscl,rebin(a,b*s[1],b*s[2]),c,d
return
end

PRO tvm,a,b,c,d
if (N_PARAMS() LT 2) then b=1
s=size(a)
if (N_PARAMS() LT 3) then tv,rebin(a,b*s[1], b*s[2]) $
else tv,rebin(a,b*s[1],b*s[2]),c,d
return
end

function gf,last,silent=silent,dir=dir
if (NOT KEYWORD_SET(dir)) then dir=''
z=findfile(dir+'M*.fits')
if (NOT KEYWORD_SET(silent)) then print,N_ELEMENTS(z),' files'
if (N_ELEMENTS(last) GE 0) then last=z[N_ELEMENTS(z)-1]
return,z
end

function gfn,last,silent=silent,dir=dir
if (NOT KEYWORD_SET(dir)) then dir=''
z=findfile(dir+'M*.fits')
nz = N_ELEMENTS(z)
ok = bytarr(nz)
for i=0,nz-1 do begin
   a = obj_new('fitsfile',z[i])
   ok[i] = N_ELEMENTS(a->listextensions()) GT 2
   a->close
   obj_destroy,a
endfor
if (total(ok) GT 0) then zz = z(where(ok)) else zz=''
if (NOT KEYWORD_SET(silent)) then print,N_ELEMENTS(zz),' files'
if (N_ELEMENTS(last) GE 0) then last=zz[N_ELEMENTS(zz)-1]
RETURN,zz
END


function gfu,last,silent=silent,dir=dir
if (NOT KEYWORD_SET(dir)) then dir='.'
spawn,'find '+dir+' -name "M*.fits" -size +1000 -print >fitslist'
openr,unit,'fitslist',/get_lun
z=''
ll=''
readf,unit,z
while(not eof(unit)) do begin readf,unit,ll&z=[z,ll]&endwhile
close,1
if (NOT KEYWORD_SET(silent)) then print,N_ELEMENTS(z),' files'
if (N_ELEMENTS(last) GE 0) then last=z[N_ELEMENTS(z)-1]
RETURN,z
END

function getfits, firstfile, nfile
f = gf(/silent)
t = size(firstfile,/type)
if (t eq 7) then begin
   first = where(strpos(f, firstfile) GE 0)
   if (max(first) eq -1) then begin
      print, 'No files found containing '+firstfile
      return,''
   endif else if (N_ELEMENTS(first) GT 1) then begin
      print, 'More than one files contain '+firstfile
      print, f(first)
      return,''
   endif 
   first = first[0]
endif else first = firstfile
return, f(first:first+nfile-1)
end

PRO meancube, firstfile, nfile, d1, d2, d3, d4, d5, d6, silent=silent
f = getfits(firstfile, nfile)
if (f[0] eq '') then return
nfiles = N_ELEMENTS(f)
idata = obj_new('imagedata', f[0])
data = idata->readrows()
dcol = idata->datacolumns()-1
ndata = n_elements(dcol)
nrows = n_elements(data)
s = size(data.(dcol[0])) & d1 = fltarr(s[1], s[2], nfiles)
if (ndata gt 1) then s = size(data.(dcol[1])) & d2 = fltarr(s[1], s[2], nfiles)
if (ndata gt 2) then s = size(data.(dcol[2])) & d3 = fltarr(s[1], s[2], nfiles)
if (ndata gt 3) then s = size(data.(dcol[3])) & d4 = fltarr(s[1], s[2], nfiles)
if (ndata gt 4) then s = size(data.(dcol[4])) & d5 = fltarr(s[1], s[2], nfiles)
if (ndata gt 5) then s = size(data.(dcol[5])) & d6 = fltarr(s[1], s[2], nfiles)
idata->close
obj_destroy,idata
for ifile =0, nfiles-1 do begin
   if(not KEYWORD_SET(silent)) then print,ifile,' ',f[ifile] 
   data = oirgetdata(f[ifile])
   d1(*,*,ifile) = total(float(data.data1),3)/n_elements(data)
   if (ndata gt 1) then d2(*,*,ifile) = total(float(data.data2),3)/n_elements(data)
   if (ndata gt 2) then d3(*,*,ifile) = total(float(data.data3),3)/n_elements(data)
   if (ndata gt 3) then d4(*,*,ifile) = total(float(data.data4),3)/n_elements(data)
   if (ndata gt 4) then d5(*,*,ifile) = total(float(data.data5),3)/n_elements(data)
   if (ndata gt 5) then d6(*,*,ifile) = total(float(data.data6),3)/n_elements(data)
endfor
return
end

pro readchop,f1,np, a1, a2, a1sum, a2sum
f=gf()
a1=fltarr(62,69,np)
a2=a1
j=0
for i=f1,f1+np-1 do begin
   a=oirgetmeanrms(f[i])
   a1(*,*,j)=a[0].data1
   a2(*,*,j)=a[0].data2
   j=j+1
endfor
for j=0, np-1, 2 do begin
   a1(*,*,j)=-a1(*,*,j)
   a2(*,*,j)=-a2(*,*,j)
endfor

a1sum = total(a1,3)/np
a2sum = total(a2,3)/np

return
end

function unstripe,image,dy
s=size(image)
z=total(image(*,0:dy-1),2)+total(image(*,(s[2]-dy):*),2)
z=.5*z/dy
for i=0,s[2]-1 do image(*,i)=image(*,i)-z
return,image
end

pro getcube,fs,nc
f=gf()
return
end

pro makenewMask, oldmask, newmask, x1, y1, x2, y2, dx
maskdata = oirgetdata(oldmask)
det = obj_new('imagedetector',oldmask)&ndata = det->getpar('NREGION')
dettable=det->readrows()
corner=dettable.corner
det->close
obj_destroy,det
maskdata.data1[*] = 0.
maskdata.data2[*] = 0.
a = fix([x1,y1]+.5) - corner(*,0)
print,a
maskdata.data1[a[0]-dx:a[0]+dx, a[1]-dx:a[1]+dx] = 1.
a = fix([x2,y2]+.5) - corner(*,1)
print,a
maskdata.data2[a[0]-dx:a[0]+dx, a[1]-dx:a[1]+dx] = 1.
oirNewData, oldmask, newmask, maskdata
return
end

function rms,a
z=mean(a)
return,sqrt(mean((a-z)^2))
end

function dcombine, data, dx, dy, rel2
if (N_PARAMS() LT 4) then rel2 = 1.
r1 = float(data.data1)+32768.
r2 = float(data.data2)+32768.
nd = n_elements(data)
t1 = total(r1,3)/nd
t2 = total(r2,3)/nd
for i=0, nd-1 do r1(*,*,i)=r1(*,*,i)-t1
print,'finished r1'
for i=0, nd-1 do r2(*,*,i)=r2(*,*,i)-t2
print,'finished r2'
for i=0, nd-1 do r1(*,*,i)=r1(*,*,i)-rel2*shift(r2(*,*,i), dx, dy)
return,r1
end

function cubesmooth, data, dx
s=size(data)
output=data
for i=0,s[3]-1 do begin
   z = reform(data(*,*,i))
   zz = ffsmooth(z, dx)
   output(*,*,i)= zz
endfor
return,output
end

function cubesharp, data, dx
s=size(data)
output=data
for i=0,s[1]-1 do for j=0,s[2]-1 do output(i,j,*)= $
   data(i,j,*)-ffsmooth1(reform(data(i,j,*)),dx)
return,output
end

function filterscans, opd, fringe, scansize, fftobj, srms, trms
nscan = n_elements(opd)/scansize
lopd = reform(opd, scansize, nscan)
lfringe=reform(fringe,scansize,nscan)
fopd = fftobj->coord()
output=fltarr(n_elements(fopd), nscan)
for i=0, nscan-1 do output(*,i)=fftobj->filter(lopd(*,i), lfringe(*,i))
if (total(finite(output) eq 0) gt 0) then output(where(finite(output) eq 0)) = 0
srms = fltarr(nscan)
for i=0,nscan-2 do srms(i)=max(abs(output(*,i)))
srms(nscan-2) = median(srms)
trms = mean(srms)
srms=srms/trms
print,'max of scans over mean ',max(srms)
return,output
end

function filterscans2, opd, fringe, scansize, fftobj, srms, trms
nscan = n_elements(opd)/scansize
lopd = reform(opd, scansize, nscan)
lfringe=reform(fringe,scansize,nscan)
fopd = fftobj->coord()
output=fltarr(n_elements(fopd), nscan)
for i=0, nscan-1 do output(*,i)=abs(fftobj->cfilter(lopd(*,i), lfringe(*,i)))
srms = fltarr(nscan)
if (total(finite(output) eq 0) gt 0) then output(where(finite(output) eq 0)) = 0
for i=0,nscan-2 do srms(i)=max(abs(output(*,i)))
srms(nscan-2) = median(srms)
trms = mean(srms)
srms=srms/trms
print,'max of scans over mean ',max(srms)
return,output
end

function filterpower, opd, fringe, scansize, fftobj, power
nscan = n_elements(opd)/scansize
lopd = reform(opd, scansize, nscan)
wt = replicate(1., scansize)
lfringe=reform(fringe,scansize,nscan)
fopd = fftobj->coord()
output=fltarr(n_elements(fopd), nscan)
power = output 
for i=0, nscan-1 do begin
   output(*,i)=fftobj->filter(lopd(*,i), lfringe(*,i),  wt, fftpower)
   power(*,i) = abs(fftpower)^2
endfor
if (total(finite(output) eq 0) gt 0)then power(where(finite(power) eq 0)) = 0
return,output
end

function cuberms,data
s=size(data)
mdata = total(data,3)/s[3]
rdata=mdata
for i=0,s[3]-1 do rdata=rdata+(data(*,*,i)-mdata)^2
return, sqrt(rdata/s[3])
end

function makefftobject, minopd, maxopd, npt, filtername
ff = obj_new('fft1d', [minopd, (maxopd-minopd)/npt, npt])
kk=ff->kgrid()
filter=obj_new('filterdata', filtername)
fdata=filter->interpolate(kk)
fdata=fdata+reverse(fdata)
ff->set,filter=fdata
obj_destroy,filter
return,ff
end

function makefftobject2, minopd, maxopd, npt, filtername
ff = obj_new('fft1d', [minopd, (maxopd-minopd)/npt, npt])
kk=ff->kgrid()
filter=obj_new('filterdata', filtername)
fdata=filter->interpolate(kk)
fdata=fdata
ff->set,filter=fdata
obj_destroy,filter
return,ff
end

pro makemovie, fftobject, scans
s = size(scans)
fopd = 1.e6*fftobject->coord()
yr=[min(scans), max(scans)]
for i=0,s[2]-1 do begin plot,fopd, scans(*,i),yr=yr&wait,.02&endfor
return
end

function crosscube, data
   r1 = float(data.data1)
   r2 = float(data.data2)
   nd = n_elements(data)
   t1 = total(r1,3)/nd
   t2 = total(r2,3)/nd
   for i=0, nd-1 do r1(*,*,i)=r1(*,*,i)-t1
   print,'finished r1'
   for i=0, nd-1 do r2(*,*,i)=r2(*,*,i)-t2
   print,'finished r2'
   cc=fltarr(7,7)
   for i=-3,3 do for j=-3,3 do cc(i+3,j+3)=total(r1*shift(r2,i,j,0))
   cc=cc/max(cc)
   print,0,-3+indgen(7),format='(i2,2x,7f7.3)'
   for j=-3,3 do print,j,cc(*,j+3),format='(i2,2x,7f7.3)'
return,cc
end

FUNCTION midiGui, dir=dir
IF (NOT KEYWORD_SET(dir)) then dir=''
f = obj_new('fitsfilelist',dir=dir,$
   guikey=['OBS TARG NAME','NRTS MODE','INS GRIS','INS OPT1','INS SHUT'],$
   guisearch='MIDI*.fits',/midiCompress)
list =f->files()
obj_destroy,f
return,list
end

PRO doscan,infile,maskfile,filterfile,opd,raw,fopd,filtered
print,'read data from ',infile
data = oircompressdata(infile,maskfile,opd=opd)
raw=data.data1-data.data2
raw=raw-fsmooth1(raw,50)
raw=reform(raw,48,100)
opd=reform(opd,48,100)
opd(47,*)=opd(45,*)
opd(46,*)=opd(45,*)
nfreq=1024.
print,'create filter object from ',filterfile
filter=obj_new('filterdata',filterfile)
fftobj=obj_new('fft1d',[-2.e-3,4.e-3/nfreq,nfreq])
fftobj->set,filter=filter->interpolate(fftobj->kgrid())
fopd=fftobj->coord()
filtered=fltarr(nfreq,100)
print,'filter data'
for i=0,99 do filtered(*,i)=abs(fftobj->filter(opd(*,i),raw(*,i)))
obj_destroy,filter
obj_destroy,fftobj
return
end

PRO ph,a,b
if (N_PARAMS() LT 2) then b = 100
if (a NE 0) AND (0 EQ (a MOD b)) then PRINT,A,format='(i,$)'
RETURN
END
