;
; This file is part of MIA.
;
; MIA is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIA; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;********************************************************
;#class#
;midiUtilities
;#description#
;general, mostly undocumented midi utilities
;#end_class#
;*******************************************************

PRO tvsclm,a,b,c,d
if (N_PARAMS() LT 2) then b=1
s=size(a)
if (N_PARAMS() LT 3) then tvscl,rebin(a,b*s[1], b*s[2]) $
else tvscl,rebin(a,b*s[1],b*s[2]),c,d
return
end

PRO tvm,a,b,c,d
if (N_PARAMS() LT 2) then b=1
s=size(a)
if (N_PARAMS() LT 3) then tv,rebin(a,b*s[1], b*s[2]) $
else tv,rebin(a,b*s[1],b*s[2]),c,d
return
end

FUNCTION gf,last,silent=silent,dir=dir
if (NOT KEYWORD_SET(dir)) then dir=''
z=findfile(dir+'M*.fits')
if (NOT KEYWORD_SET(silent)) then print,N_ELEMENTS(z),' files'
if (N_ELEMENTS(last) GE 0) then last=z[N_ELEMENTS(z)-1]
return,z
end

FUNCTION gfn,last,silent=silent,dir=dir
if (NOT KEYWORD_SET(dir)) then dir=''
z=findfile(dir+'M*.fits')
nz = N_ELEMENTS(z)
ok = bytarr(nz)
for i=0,nz-1 do begin
   a = obj_new('fitsfile',z[i])
   ok[i] = N_ELEMENTS(a->listextensions()) GT 2
   a->close
   obj_destroy,a
endfor
if (total(ok) GT 0) then zz = z(where(ok)) else zz=''
if (NOT KEYWORD_SET(silent)) then print,N_ELEMENTS(zz),' files'
if (N_ELEMENTS(last) GE 0) then last=zz[N_ELEMENTS(zz)-1]
RETURN,zz
END


FUNCTION gfu,last,silent=silent,dir=dir
if (NOT KEYWORD_SET(dir)) then dir='.'
spawn,'find '+dir+' -name "M*.fits" -size +1000 -print >fitslist'
openr,unit,'fitslist',/get_lun
z=''
ll=''
readf,unit,z
while(not eof(unit)) do begin readf,unit,ll&z=[z,ll]&endwhile
close,1
if (NOT KEYWORD_SET(silent)) then print,N_ELEMENTS(z),' files'
if (N_ELEMENTS(last) GE 0) then last=z[N_ELEMENTS(z)-1]
RETURN,z
END

FUNCTION getfits, firstfile, nfile
f = gf(/silent)
t = size(firstfile,/type)
if (t eq 7) then begin
   first = where(strpos(f, firstfile) GE 0)
   if (max(first) eq -1) then begin
      print, 'No files found containing '+firstfile
      return,''
   endif else if (N_ELEMENTS(first) GT 1) then begin
      print, 'More than one files contain '+firstfile
      print, f(first)
      return,''
   endif
   first = first[0]
endif else first = firstfile
return, f(first:first+nfile-1)
end

PRO meancube, firstfile, nfile, d1, d2, d3, d4, d5, d6, silent=silent
f = getfits(firstfile, nfile)
if (f[0] eq '') then return
nfiles = N_ELEMENTS(f)
idata = obj_new('imagedata', f[0])
data = idata->readrows()
dcol = idata->datacolumns()-1
ndata = n_elements(dcol)
nrows = n_elements(data)
s = size(data.(dcol[0])) & d1 = fltarr(s[1], s[2], nfiles)
if (ndata gt 1) then s = size(data.(dcol[1])) & d2 = fltarr(s[1], s[2], nfiles)
if (ndata gt 2) then s = size(data.(dcol[2])) & d3 = fltarr(s[1], s[2], nfiles)
if (ndata gt 3) then s = size(data.(dcol[3])) & d4 = fltarr(s[1], s[2], nfiles)
if (ndata gt 4) then s = size(data.(dcol[4])) & d5 = fltarr(s[1], s[2], nfiles)
if (ndata gt 5) then s = size(data.(dcol[5])) & d6 = fltarr(s[1], s[2], nfiles)
idata->close
obj_destroy,idata
for ifile =0, nfiles-1 do begin
   if(not KEYWORD_SET(silent)) then print,ifile,' ',f[ifile]
   data = oirgetdata(f[ifile])
   d1(*,*,ifile) = total(float(data.data1),3)/n_elements(data)
   if (ndata gt 1) then d2(*,*,ifile) = total(float(data.data2),3)/n_elements(data)
   if (ndata gt 2) then d3(*,*,ifile) = total(float(data.data3),3)/n_elements(data)
   if (ndata gt 3) then d4(*,*,ifile) = total(float(data.data4),3)/n_elements(data)
   if (ndata gt 4) then d5(*,*,ifile) = total(float(data.data5),3)/n_elements(data)
   if (ndata gt 5) then d6(*,*,ifile) = total(float(data.data6),3)/n_elements(data)
endfor
return
end

pro readchop,f1,np, a1, a2, a1sum, a2sum
f=gf()
a1=fltarr(62,69,np)
a2=a1
j=0
for i=f1,f1+np-1 do begin
   a=oirgetmeanrms(f[i])
   a1(*,*,j)=a[0].data1
   a2(*,*,j)=a[0].data2
   j=j+1
endfor
for j=0, np-1, 2 do begin
   a1(*,*,j)=-a1(*,*,j)
   a2(*,*,j)=-a2(*,*,j)
endfor

a1sum = total(a1,3)/np
a2sum = total(a2,3)/np

return
end

FUNCTION unstripe,image,dy
s=size(image)
z=total(image(*,0:dy-1),2)+total(image(*,(s[2]-dy):*),2)
z=.5*z/dy
for i=0,s[2]-1 do image(*,i)=image(*,i)-z
return,image
end

pro getcube,fs,nc
f=gf()
return
end

pro makenewMask, oldmask, newmask, x1, y1, x2, y2, dx
maskdata = oirgetdata(oldmask)
det = obj_new('imagedetector',oldmask)&ndata = det->getpar('NREGION')
dettable=det->readrows()
corner=dettable.corner
det->close
obj_destroy,det
maskdata.data1[*] = 0.
maskdata.data2[*] = 0.
a = fix([x1,y1]+.5) - corner(*,0)
print,a
maskdata.data1[a[0]-dx:a[0]+dx, a[1]-dx:a[1]+dx] = 1.
a = fix([x2,y2]+.5) - corner(*,1)
print,a
maskdata.data2[a[0]-dx:a[0]+dx, a[1]-dx:a[1]+dx] = 1.
oirNewData, oldmask, newmask, maskdata
return
end

FUNCTION rms,a
z=mean(a)
return,sqrt(mean((a-z)^2))
end

FUNCTION dcombine, data, dx, dy, rel2
if (N_PARAMS() LT 4) then rel2 = 1.
r1 = float(data.data1)+32768.
r2 = float(data.data2)+32768.
nd = n_elements(data)
t1 = total(r1,3)/nd
t2 = total(r2,3)/nd
for i=0, nd-1 do r1(*,*,i)=r1(*,*,i)-t1
print,'finished r1'
for i=0, nd-1 do r2(*,*,i)=r2(*,*,i)-t2
print,'finished r2'
for i=0, nd-1 do r1(*,*,i)=r1(*,*,i)-rel2*shift(r2(*,*,i), dx, dy)
return,r1
end

FUNCTION cubesmooth, data, dx
s=size(data)
output=data
for i=0,s[3]-1 do begin
   z = reform(data(*,*,i))
   zz = ffsmooth(z, dx)
   output(*,*,i)= zz
endfor
return,output
end

FUNCTION cubesharp, data, dx
s=size(data)
output=data
for i=0,s[1]-1 do for j=0,s[2]-1 do output(i,j,*)= $
   data(i,j,*)-ffsmooth1(reform(data(i,j,*)),dx)
return,output
end

FUNCTION filterscans, opd, fringe, scansize, fftobj, srms, trms
nscan = n_elements(opd)/scansize
lopd = reform(opd, scansize, nscan)
lfringe=reform(fringe,scansize,nscan)
fopd = fftobj->coord()
output=fltarr(n_elements(fopd), nscan)
for i=0, nscan-1 do output(*,i)=fftobj->filter(lopd(*,i), lfringe(*,i))
if (total(finite(output) eq 0) gt 0) then output(where(finite(output) eq 0)) = 0
srms = fltarr(nscan)
for i=0,nscan-2 do srms(i)=max(abs(output(*,i)))
srms(nscan-2) = median(srms)
trms = mean(srms)
srms=srms/trms
print,'max of scans over mean ',max(srms)
return,output
end

FUNCTION filterscans2, opd, fringe, scansize, fftobj, srms, trms
nscan = n_elements(opd)/scansize
lopd = reform(opd, scansize, nscan)
lfringe=reform(fringe,scansize,nscan)
fopd = fftobj->coord()
output=fltarr(n_elements(fopd), nscan)
for i=0, nscan-1 do output(*,i)=abs(fftobj->cfilter(lopd(*,i), lfringe(*,i)))
srms = fltarr(nscan)
if (total(finite(output) eq 0) gt 0) then output(where(finite(output) eq 0)) = 0
for i=0,nscan-2 do srms(i)=max(abs(output(*,i)))
srms(nscan-2) = median(srms)
trms = mean(srms)
srms=srms/trms
print,'max of scans over mean ',max(srms)
return,output
end

FUNCTION filterpower, opd, fringe, scansize, fftobj, power
nscan = n_elements(opd)/scansize
lopd = reform(opd, scansize, nscan)
wt = replicate(1., scansize)
lfringe=reform(fringe,scansize,nscan)
fopd = fftobj->coord()
output=fltarr(n_elements(fopd), nscan)
power = output
for i=0, nscan-1 do begin
   output(*,i)=fftobj->filter(lopd(*,i), lfringe(*,i),  wt, fftpower)
   power(*,i) = abs(fftpower)^2
endfor
if (total(finite(output) eq 0) gt 0)then power(where(finite(power) eq 0)) = 0
return,output
end

FUNCTION cuberms,data
s=size(data)
mdata = total(data,3)/s[3]
rdata=mdata
for i=0,s[3]-1 do rdata=rdata+(data(*,*,i)-mdata)^2
return, sqrt(rdata/s[3])
end

FUNCTION makefftobject, minopd, maxopd, npt, filtername
ff = obj_new('fft1d', [minopd, (maxopd-minopd)/npt, npt])
kk=ff->kgrid()
filter=obj_new('filterdata', filtername)
fdata=filter->interpolate(kk)
fdata=fdata+reverse(fdata)
ff->set,filter=fdata
obj_destroy,filter
return,ff
end

FUNCTION makefftobject2, minopd, maxopd, npt, filtername
ff = obj_new('fft1d', [minopd, (maxopd-minopd)/npt, npt])
kk=ff->kgrid()
filter=obj_new('filterdata', filtername)
fdata=filter->interpolate(kk)
fdata=fdata
ff->set,filter=fdata
obj_destroy,filter
return,ff
end

pro makemovie, fftobject, scans
s = size(scans)
fopd = 1.e6*fftobject->coord()
yr=[min(scans), max(scans)]
for i=0,s[2]-1 do begin plot,fopd, scans(*,i),yr=yr&wait,.02&endfor
return
end

FUNCTION crosscube, data
   r1 = float(data.data1)
   r2 = float(data.data2)
   nd = n_elements(data)
   t1 = total(r1,3)/nd
   t2 = total(r2,3)/nd
   for i=0, nd-1 do r1(*,*,i)=r1(*,*,i)-t1
   print,'finished r1'
   for i=0, nd-1 do r2(*,*,i)=r2(*,*,i)-t2
   print,'finished r2'
   cc=fltarr(7,7)
   for i=-3,3 do for j=-3,3 do cc(i+3,j+3)=total(r1*shift(r2,i,j,0))
   cc=cc/max(cc)
   print,0,-3+indgen(7),format='(i2,2x,7f7.3)'
   for j=-3,3 do print,j,cc(*,j+3),format='(i2,2x,7f7.3)'
return,cc
end

FUNCTION midiGui, fileObj, dir=dir, search=search, save=save, restore=restore
;

   IF (NOT KEYWORD_SET(dir)) then dir=''
   IF(NOT KEYWORD_SET(search)) then search = 'MIDI*.fits'
   if (NOT KEYWORD_SET(restore)) then begin
      if (dir EQ '') then begin
         cd,current=c
         print,'Reading files in current directory '+c
      endif else print,'Reading files in directory '+dir
      f = obj_new('fitsfilelist',dir=dir,$
;     guikey=['OBJECT','NRTS MODE','INS GRIS','INS OPT1','INS FILT NAME',$
      guikey=['OBS TARG','NRTS MODE','INS GRIS','INS OPT1','INS FILT NAME',$
         'INS SHUT'],guisearch=search,/midiCompress) 
   endif else begin
      if (STRTRIM(OBJ_CLASS(fileObj),2) NE 'FITSFILELIST') then begin
         print,'restore variable is not an old fitsfilelist'
         RETURN,''
      endif
      f = fileObj
      f->guiSelect
   endelse
   if (OBJ_VALID(f)) then list =f->files() else list = ''
   if (KEYWORD_SET(save)) then fileObj = f else OBJ_DESTROY,f
RETURN,list
END

FUNCTION midiGuiS, dir=dir
;
   search='MIDI*.fits'
   IF (NOT KEYWORD_SET(dir)) then dir=''
   if (dir EQ '') then begin
      cd,current=c
      print,'Reading files in current directory '+c
      saveFileName = 'midiGui.SAV'
   endif else begin
      print,'Reading files in directory '+dir
      saveFileName = dir+'/midiGui.SAV'
   endelse 
   saveFile = (FINDFILE(saveFileName))[0]
   if (saveFile NE '') then begin
      f = OBJ_NEW('fitsfilelist',restore=saveFile) 
      f->guiSelect
   endif else begin
      f = obj_new('fitsfilelist',dir=dir,$
      guikey=['OBS TARG','NRTS MODE','INS GRIS','INS OPT1','INS FILT NAME',$
         'INS SHUT'],guisearch=search,/midiCompress) 
   endelse 
   if (OBJ_VALID(f)) then list =f->files() else list = ''
   if (saveFile EQ '') then f->save, saveFileName
   OBJ_DESTROY,f
RETURN,list
END

FUNCTION midiFiles, last, dir=dir
;
   IF (NOT KEYWORD_SET(dir)) then dir='.'
   f = obj_new('fitsfilelist',dir=dir,$
      search='MIDI*.fits',/midiCompress)
   list =f->files()
   last = list[N_ELEMENTS(list) -1]
   obj_destroy,f
RETURN,list
END

PRO doscan,infile,maskfile,filterfile,opd,raw,fopd,filtered
print,'read data from ',infile
data = oircompressdata(infile,maskfile,opd=opd)
raw=data.data1-data.data2
raw=raw-fsmooth1(raw,50)
raw=reform(raw,48,100)
opd=reform(opd,48,100)
opd(47,*)=opd(45,*)
opd(46,*)=opd(45,*)
nfreq=1024.
print,'create filter object from ',filterfile
filter=obj_new('filterdata',filterfile)
fftobj=obj_new('fft1d',[-2.e-3,4.e-3/nfreq,nfreq])
fftobj->set,filter=filter->interpolate(fftobj->kgrid())
fopd=fftobj->coord()
filtered=fltarr(nfreq,100)
print,'filter data'
for i=0,99 do filtered(*,i)=abs(fftobj->filter(opd(*,i),raw(*,i)))
obj_destroy,filter
obj_destroy,fftobj
return
end

PRO ph,a,b
if (N_PARAMS() LT 2) then b = 100
if (a NE 0) AND (0 EQ (a MOD b)) then PRINT,A,format='(i,$)'
RETURN
END

pro olines,lines,labels,ylab,th
; on top of existing plot make vertical stripes at
; the positions of given spectral lines
; shift each wavelength before plotting by z
; default line thickness
   if (n_params() eq 4) then t=th else t = 1
;  loop over list of lines
   if (n_params() eq 2) then ylab = .8*!y.crange(1)
   xr=!x.crange
   if (!x.type eq 1) then xr=10.^xr
   n=n_elements(lines)-1
   for i=0,n do begin
      zl = lines[i]
;  only over plot lines that fall within wavelength range of plot
;  the x-coordinate could be logarithmic
      if (zl gt xr(0)) and (zl lt xr(1)) then begin
         if (t gt 0) then oplot,[zl,zl],!y.crange,thick=t
;  if a list of line names have been given, write these on plot
      if n_params() gt 2 then xyouts,zl,ylab,labels(i),orient=90
      endif
   endfor
return
end

FUNCTION pex,d,x
;  if d is list of polynomial coefficients, expand
;  polynomial at each value of vector x and return vector of values
p = n_elements(d)
w = d(p-1)
for i=p-2,0,-1 do w=w*x+d(i)
return,w
end

FUNCTION pex2,d,x,y
p = size(d)
cox=fltarr(p(1))
for i=0,p(1) -1 do cox(i) = pex(d(i,*),y)
return, pex(cox, x)
end 

FUNCTION medcont, data
; return median of a vertical stack of images
ss=size(data)
out=fltarr(ss(1),ss(2))
for i=0,ss(1)-1 do for j=0,ss(2)-1 do out(i,j)=median(data(i,j,*))
return,out
end

FUNCTION ps1,a,dx
;shift an 1-d array a by dx (fractional) pixels
pi2 = 2.*!pi
f = fft(a,1)
ss = size(a)
nx = ss(1)
sx = exp(complex (0, pi2 * dx * (indgen(nx) - nx/2)/nx))
sx = shift (sx, -nx/2)
f=f*sx
return, float(fft(f,-1))
end


FUNCTION bblam,temp,wave
;  return normalized bb curve in energy/area/sec/wavelength unit
;  given wavelengths in microns, temp in K and n is normalizing point
z = wave^(-5)/(exp(14350./(temp*wave))-1.)
n=fix(.5*n_elements(wave))
return, z/z(n)
end

FUNCTION bbJy,temp,wave
;  return normalized bb curve in energy/area/sec/Hz unit
;  given wavelengths in microns, temp in K and n is normalizing point
z = wave^(-3)/(exp(14350./(temp*wave))-1.)
n=fix(.5*n_elements(wave))
return, z/z(n)
end

FUNCTION pk,x,y,z
; using quadratic approximation of y(x) return
; position (x value) of peak of y to subpixel accuracy
; optionally return interpolated y value in z
   q=max(y,j)
   if (j eq 0) then j = 1
   if (j eq n_elements(x)-1) then j=n_elements(x)-2
   dj=(y(j-1)-y(j+1))*.5/(y(j+1)+y(j-1)-2.*y(j))
   z = y(j)+.25*dj*(y(j+1)-y(j-1))
return,x(j)+.5*dj*(x(j+1)-x(j-1))
end

FUNCTION pshift,a,dx,dy
;two dimensional partial pixel shift
pi2 = 2.*!pi
f = fft(a,1)
ss = size(a)
nx = ss(1)
ny = ss(2)
sx = exp(complex (0, pi2 * dx * (indgen(nx) - nx/2)/nx))
sx = shift (sx, -nx/2)
for i = 0, ny - 1 do f(*,i) = f(*,i) * sx
sy = exp(complex (0, pi2 * dy * (indgen(ny)-ny/2)/ny))
sy = shift (sy, -ny/2)
for i = 0, nx - 1 do f(i,*) = f(i,*) * sy
return, float(fft(f,-1))
end
FUNCTION ps1,a,dx
pi2 = 2.*!pi
f = fft(a,1)
ss = size(a)
nx = ss(1)
sx = exp(complex (0, pi2 * dx * (indgen(nx) - nx/2)/nx))
sx = shift (sx, -nx/2)
f=f*sx
return, float(fft(f,-1))
end
FUNCTION cross,a,b
return,float(fft(fft(a,1)*fft(b,-1),-1))
end
FUNCTION makex,nx,ny
mask = intarr(nx, ny)
x = indgen(nx)
for i=0,ny-1 do mask(*, i) = x
return,mask
end
FUNCTION makey,nx,ny
mask = intarr(nx, ny)
x = indgen(ny)
for i=0,nx-1 do mask(i, *) = x
return,mask
end


FUNCTION gau,nx,ny,sx,sy
g = (shift((makex(nx,ny)-.5*nx)/sx,nx/2,0))^2
g = .5*(g + (shift((makey(nx,ny)-.5*ny)/sy,0,ny/2))^2)
if (total(g gt 30.) gt 0) then g(where(g gt 30.)) = 30.
return ,exp(-g)
end

FUNCTION gau1,nx,sx
if (sx lt .001) then sx = .001
g = .5*(shift((indgen(nx)-.5*nx)/sx,nx/2))^2
if (total(g gt 30.) gt 0) then g(where(g gt 30.)) = 30.
return ,exp(-g)
end

FUNCTION fgau,nx,ny,sx,sy
f=fft(gau(nx,ny,sx,sy),1)
return,f/f(0,0)
end
FUNCTION fgau1,nx,sx
f=fft(gau1(nx,sx),1)
return,f/f(0)
end

FUNCTION fsmooth,image,s
; two dimensional fft smoothing of image
ss=size(image)
g=fgau(ss(1),ss(2),s,s)
return,float(fft(g*fft(image,1),-1))
end

FUNCTION fsmooth1,image,s
ss=size(image)
g=fgau1(ss(1),s)
return,float(fft(g*fft(image,1),-1))
end

FUNCTION csmooth1,image,s
ss=size(image)
g=fgau1(ss(1),s)
return,fft(g*fft(image,1),-1)
end


FUNCTION fsmooth2,image,s1,s2
ss=size(image)
g=fgau(ss(1),ss(2),s1,s2)
return,float(fft(g*fft(image,1),-1))
end


PRO sortmask,oldfile,newfile
olddet = obj_new('imagedetector', oldfile)
olddetdata=olddet->readrows()
olddet->close
yorder = sort(olddetdata.corner[1])
print,olddetdata.corner[1]
print,olddetdata[yorder].corner[1]
newdetdata=olddetdata[yorder]
for i=0,n_elements(yorder)-1 do newdetdata[i].region=i+1
oldtable=olddet->table()
*oldtable=newdetdata
olddata = obj_new('imagedata',oldfile)
olddatacols = olddata->datacolumns()-1
oldmask = olddata->readrows()
obj_destroy,olddata
newtemp=olddet->datatemplate(/float)

olddet->newfile, newfile
newdata = obj_new('imagedata', olddet,/float)
newdatacols=newdata->datacolumns()-1
for i=0,n_elements(yorder)-1 do newtemp.(newdatacols[i])= $
   oldmask.(olddatacols[yorder[i]])
newdata->appendtofile, olddet
newdata->writerows,newtemp
newdata->close
obj_destroy,newdata
RETURN
END


PRO sortwindow,oldfile,newfile
olddet = obj_new('imagedetector', oldfile)
olddetdata=olddet->readrows()
olddet->close
yorder = sort(olddetdata.corner[1])
print,olddetdata.corner[1]
print,olddetdata[yorder].corner[1]
newdetdata=olddetdata[yorder]
for i=0,n_elements(yorder)-1 do newdetdata[i].region=i+1
oldtable=olddet->table()
*oldtable=newdetdata
olddata = obj_new('imagedata',oldfile)
olddatacols = olddata->datacolumns()-1
obj_destroy,olddata
olddet->newfile, newfile
newdata = obj_new('imagedata', olddet,/int)
newdata->appendtofile, olddet
newdata->close
obj_destroy,newdata
RETURN
END

PRO listmask,filelist,outfile
   nFile = N_ELEMENTS(filelist)
   openw,unit,outfile,/get_lun
   for iFile = 1, nFile do begin
      name=filelist[iFile-1]
      det=obj_new('imagedetector', name)
      detdata=det->readrows()
      nRows = N_ELEMENTS(detdata)
      printf,unit,name+':'
      for iRow=0, nRows-1 do begin
         region=strtrim(detdata[iRow].region,2)
         d=detdata[iRow]
         outs='DET.WIN'+region+'.STARTX '
         outs=outs+strtrim(d.corner[0],2)+' DET.WIN'+region+'.STARTY '
         outs=outs+strtrim(d.corner[1],2)+' DET.WIN'+region+'.NX '
         outs=outs+strtrim(d.naxis[0],2)+' DET.WIN'+region+'.NY '
         outs=outs+strtrim(d.naxis[1],2)+' (Corr: '+strtrim(d.correlation,2)+')'
         printf,unit,outs
      endfor
      printf,unit,' '
   endfor
   FREE_LUN,unit
RETURN
END

PRO fixwindow,oldfile
   newfile = oldfile+'.tmp'
   olddet = obj_new('imagedetector', oldfile)
   olddetdata=olddet->readrows()
   olddet->close
   nWindows = N_ELEMENTS(olddetdata)
   newdetdata=olddetdata
   xx = indgen(4)
   for i=0,nWindows-1 do newdetdata[i].region=i+1
   print,' found ',nWindows,' windows'
SETVALUES:
   for i=0, nWindows-1 do begin
      print,i+1,'X0','Y0','NX','NY',format='(i2,2x,4(a,4x))'
      print,olddetdata[i].corner, olddetdata[i].naxis, $
         format='(4i6)'
      read,xx
      newdetdata[i].corner= xx[0:1]
      newdetdata[i].naxis = xx[2:3]
      if (newdetdata[i].naxis[0] NE olddetdata[i].naxis[0]) $
         then print,' you changed NX, this may invalidate WCS data'
   endfor
   print,'NEW VALUES'
   for i=0, nWindows-1 do begin
      print,i+1,'X0','Y0','NX','NY',format='(i2,2x,4(a,4x))'
      print,newdetdata[i].corner, newdetdata[i].naxis, $
         format='(4i6)'
   endfor
   print,'TO REPEAT TYPE "r": TO ACCEPT TYPE "y" else I quit'
   ll = ''
   read,ll
   if (STRUPCASE(ll) EQ 'R') then GOTO,SETVALUES
   if (STRUPCASE(ll) EQ 'Y') then begin
      oldtable=olddet->table()
      *oldtable=newdetdata
      olddet->newfile, newfile
      newdata = obj_new('imagedata', olddet,/int)
      newdata->appendtofile, olddet
      newdata->close
      obj_destroy,newdata
      spawn,'mv '+oldfile+' '+oldfile+'~'
      spawn,'mv '+newfile+' '+oldfile
      print,'renamed ',oldfile,' ',oldfile+'~'
   endif
   obj_destroy,olddet
RETURN
END

PRO midiGetINS, file, dit=dit, grism=grism, slit=slit, opt1=opt1, $
   camera=camera, filter=filter, nrts=nrts, object=object, shutter=shutter, $
   ndit = ndit
;
   f = file[0]
   f = STRSPLIT(f, ' ',/EXTRACT)
   f = f[0]
   fits = OBJ_NEW('fitsfile', f)
   ph   = fits->head()
   dit  = ph->getpar('DET DIT')
   ndit  = ph->getpar('DET NDIT')
   grism = ph->getpar('INS GRIS NAME')
   slit = ph->getpar('INS SLIT NAME')
   opt1 = ph->getpar('INS OPT1 NAME')
   camera = ph->getpar('INS CAM NAME')
   filter = ph->getpar('INS FILT NAME')
   shutter = ph->getpar('INS SHUT NAME')
   nrts = ph->getpar('DET NRTS MODE')
   ob   = ph->getpar('TARG NAME',nob)
   if (nob GT 0) then object=ob else object=''
   OBJ_DESTROY, ph
   OBJ_DESTROY, fits
RETURN
END

FUNCTION midiPhase, x
   RETURN,ATAN(IMAGINARY(x), FLOAT(x))
END

PRO midiDelayPlot, base, title
   delay = oirgetdelay(base+'.groupdelay.fits')
   delaytime=delay.time&delaytime=86400*(delaytime-delaytime[0])
   opd = oirgetdata(base+'.fringes.fits',col=['opd','localopd'])
   opd=1.e6*reform((opd.opd[1]+opd.localopd[1]-opd.opd[0]-opd.localopd[0]))
   delay = reform(delay.delay)
   if (TOTAL(opd EQ 0.) GT 0 ) then begin
      delay(where(opd EQ 0.0)) = median(reform(delay)); bad points
      opd(where(opd EQ 0.0)) = median(opd)  ; bad points
   endif
   plot,delaytime, opd,yrange=[min([opd,delay]),max([opd,delay])],title=base+':'+title
   oplot,delaytime,delay
RETURN
END

PRO midiInsVisPlot, base,title
   vis = oirGetVis(base+'.redcal.fits', wave=wave)
   plot,wave,vis.visamp,xr=[7.5,13.5],xstyle=1,title=base+':'+title
   errplot,wave,vis.visamp-vis.visamperr,vis.visamp+vis.visamperr
RETURN
END

PRO midiPhotoPipe, tag, files=files, mask=mask
   cbin = getenv('drsRoot')+'/software/EWS/c/bin/'
   if (NOT KEYWORD_SET(files)) then d = midiGuis() else d=files
   if (N_ELEMENTS(mask) LE 0) then mask='$midiutil/prismnewmask.fits'
   fileList = REPLICATE(-1,2)
   for i=0,2 do begin
      midiGetIns,d[i],shutter=shutter, grism=grism
      grism=STRTRIM(grism,2)
      shutter = STRTRIM(shutter,2)
      if (shutter EQ 'AOPEN') then fileList[0]=i $
      else if (shutter EQ 'BOPEN') then fileList[1] = i 
      if ((grism NE 'PRISM') AND (grism NE 'GRISM')) then begin
         print,'I only know how to deal with prism or grism data'
         RETURN
      endif
   endfor

   if (total(filelist EQ (-1)) NE 0) then begin
       print,'I need PA+PB to continue'
       RETURN
   endif
   command = cbin+'dispPhot '+d[filelist[0]]+' '+d[filelist[1]]+' '+mask+' '+base
   spawn,command
RETURN
END

PRO midiPipe, base, files=files, mask=mask
   cbin = getenv('drsRoot')+'/software/EWS/c/bin/'
   if (NOT KEYWORD_SET(files)) then d = midiGuis() else d=files
   if (N_ELEMENTS(mask) LE 0) then mask='$midiutil/prismnewmask.fits'
   fileList = REPLICATE(-1,3)
   for i=0,2 do begin
      midiGetIns,d[i],shutter=shutter, grism=grism, object=object
      shutter = STRTRIM(shutter,2)
      grism = STRTRIM(grism,2)
      if (shutter EQ 'AOPEN') then fileList[0]=i $
      else if (shutter EQ 'BOPEN') then fileList[1] = i $
      else if (shutter EQ 'ABOPEN') then fileList[2] = i
      if ((grism NE 'PRISM') AND (grism NE 'GRISM'))then begin
         print,'I only know how to deal with prism or grism data'
         RETURN
      endif
   endfor

   if (total(filelist EQ (-1)) NE 0) then begin
       print,'I need INT+PA+PB to continue'
       RETURN
   endif
   command = cbin+'dispVisPhot "'+d[filelist[2]]+'" "'+d[filelist[0]]+'" "'+d[filelist[1]]+'" '+mask+' '+base
   spawn,command
   spawn,cbin+'oirRedCal '+base
   !p.multi=[0,1,2,0,0]
   midiDelayPlot,base,object+':'+d[filelist[0]]
   midiInsVisPlot,base,object+':'+d[filelist[0]]
   !p.multi = 0
RETURN
END

FUNCTION reduceDay, dir=dir, infiles=infiles, outdir=outdir, base=base, mask=mask
oldx = !x
oldy = !y
!x.style=1
!y.style=1

;
   if (NOT KEYWORD_SET(outdir)) then odir='' else odir=outdir+'/'
   if (KEYWORD_SET(infiles)) then files = infiles else $
      if (KEYWORD_SET(dir)) then files=midiGuis(dir=dir) $
         else files=midiGuis()
   nFiles = N_ELEMENTS(files)
   print,'Got ',nFiles, ' Files. Proceed?'
   ll = ''
   read,ll
   if ((ll EQ 'N') OR (ll EQ 'n')) then RETURN,files

   if (0 NE (nFiles mod 3)) then begin
      print,'Number of files not divisible by 3'
      RETURN,files
   endif

   n3 = nFiles/3
   base = STRARR(n3)
   for i=0, n3-1 do begin
      midiGetIns,files[3*i+1],object=object
      base[i]=STRTRIM(object,2)
   endfor
   print,'raw base names ',base
; rename duplicates
   for i=0, n3-1 do begin
      w = WHERE(base[i] EQ base)
      nW = N_ELEMENTS(w)
      if (nW GT 1) then $
         for j=1,nW-1 do base[w[j]]=STRTRIM(base[w[j]])+'-'+STRTRIM(j,2)
   endfor
   print,'new base names ',base

   for iFile=0, n3-1 do begin
      fileList = REPLICATE(-1,3)
      d = files[3*iFile+indgen(3)]
      for i=0,2 do begin
         s = STRSPLIT(d[i],' ',/EXTRACT)
         d[i] = s[0]
         midiGetIns,d[i],shutter=shutter, grism=grism
         shutter = STRTRIM(shutter,2)
         grism = STRTRIM(grism,2)
         if (shutter EQ 'AOPEN') then fileList[0]=i 
         if (shutter EQ 'BOPEN') then fileList[1]=i 
         if (shutter EQ 'ABOPEN') then  fileList[2]=i 
         if ((grism NE 'PRISM') AND (grism NE 'GRISM')) then begin
            print,'I only know how to deal with prism or grism data'
            RETURN,files
         endif
      endfor
      if (TOTAL(fileList EQ -1) NE 0) then begin
         print,'For base ',base[iFile],' I dont have Int+2*Phot'
         RETURN,files
      endif
   endfor
   for iFile=0, n3-1 do begin
      if (STRMID(base[iFile],0,4) EQ 'MIDI') then begin
          print,'I wont process "MIDI" files'
          RETURN,files
      endif
      base[iFile] = STRTRIM(odir+base[iFile])
      if(base[iFile] EQ '') then RETURN,files
      print,iFile,' cleaning old files named '+base[iFile]+'.*.fits'
      spawn,' rm '+base[iFile]+'*.fits'
      print,iFile,' processing ',base[iFile]
      midipipe,base[iFile],files=files[3*iFile+indgen(3)],mask=mask
   endfor
!x=oldx
!y=oldy
RETURN,files
END

PRO midiCalibrate, tag, calTag, photoTag=photoTag, $
   calFlux10=calFlux10, diam=diam, noPoint=noPoint, print=print

   if (not KEYWORD_SET(calFlux10)) then calFlux10 = 1.
   doprint = KEYWORD_SET(print)
   
   if (NOT KEYWORD_SET(diam)) then diam = 0.
   cbin = getenv('drsRoot')+'/software/EWS/c/bin/'
   cmd = cbin+'oirCalibrateVis '+tag+' '+calTag + ' '
   if (KEYWORD_SET(photoTag)) then cmd = cmd + "-sp "+photoTag+" "
   if (KEYWORD_SET(calFlux10)) then cmd = cmd + "-calflux "+ $
      STRTRIM(calFlux10,2)+" "
   if (KEYWORD_SET(diam)) then cmd = cmd + "-cald "+STRTRIM(diam,2)+" "
   if (KEYWORD_SET(noPoint)) then cmd = cmd+" -nopoint"

;  spawn,cbin+'oirCalibrateVis '+tag+' '+calTag + ' '+strtrim(diam,2)
   spawn,cmd
   file = OBJ_NEW('fitsfile',caltag+'.redcal.fits')
   head = file->head()
   caldate = head->getpar('DATE-OBS')
   obj_destroy,head
   file->close
   obj_destroy,file
   file = OBJ_NEW('fitsfile',tag+'.redcal.fits')
   head = file->head()
   tardate = head->getpar('DATE-OBS')
   file->close
   obj_destroy,head
   obj_destroy,file
   plotname=!d.name
   set_plot,'ps'
   device,file=tag+'calPlots.ps',xs=15,ys=25,yo=1
   oldMulti = !p.multi
   !p.multi=[0,1,4,0,0]
   title=calTag+':'+caldate
;                   instrumental visibilities
;                   modify visamp by supplied cal flux.
   calVis = oirGetVis(calTag+'.redcal.fits',wave=wave)
   calFlux = calFlux10*100./wave^2

   !x.style=1
   !y.style=1
   !x.range=[7.5,13.5]
   xw = where(wave gt 7.6 and (wave lt 13.5))
   nw = N_ELEMENTS(xw)/8
   xer = xw[8*indgen(nw)]
   xt = 'Wavelength, (mu)'

   nWave = N_ELEMENTS(wave) -1
   nxWave = N_ELEMENTS(xw) - 1
; Calibrator; plot total A+B/2 raw flux, total mask sqrt(AB) flux raw correlated flux

   calPhot = oirgetData(calTag+'.photometry.fits')
   calCorr = oirGetVis(calTag+'.corr.fits')
;
   data = .5*(calPhot[0].data1+calPhot[1].data1)
   err  = calPhot[8].data1
   plot,wave,data,yr=[0,1.2*max(data[xw])],$
   xtitle=xt,title=title+' Raw Total Photometry'
      errplot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.RawTotalPhotometry.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif
;
   data = calPhot[5].data1
   err  = calPhot[11].data1
   plot,wave,data,yr=[0,1.2*max(data[xw])],$
      xtitle=xt,title=title+' Raw Masked Photometry'
      errplot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.RawMaskedPhotometry.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif
;
   data = calCorr[0].visamp
   err  = calCorr[0].visamperr
   plot,wave,data,yr=[0,1.2*max(data[xw])],$
      xtitle=xt,title=title+' Raw Correlated Amplitude'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]

if (doprint) then begin
   openw,unit,title+'.RawCorrelatedAmplitude.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif
;
   data = calCorr[0].visphi
   plot,wave,data, xtitle=xt,title=title+' Raw Correlated Phase'
      errPlot,wave[xer],data[xer]-calCorr[0].visphierr[xer], $
         data[xer]+calCorr[0].visphierr[xer]
if (doprint) then begin
   openw,unit,title+'.RawCorrelatedPhase.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif

;calibrator reduced values

   data = calVis[0].visamp
   err  = calVis[0].visamperr
   plot,wave,data, yr=[0,1.2*max(data[xw])], $
      xtitle=xt,title=title+' Instrumental Visibility'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.InstrumentalVisibility.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif
;
   data = calVis[0].visphi
   err  = calVis[0].visphierr
   plot,wave,data, xtitle=xt,title=title+' Instrumental Phase'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.InstrumentalPhase.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif
;
   data = .5*(calPhot[0].data1 + calPhot[1].data1)/calFlux
   err = calPhot[8].data1/calFlux
   plot,wave,data, xtitle=xt,title=title+' ADU/s/Jy ', $
      yr=[0,1.2*max(data[xw])]
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
;
;target raw values

   targVis = oirGetVis(tag+'.corr.fits')
   targphot = oirGetData(tag+'.photometry.fits')
   title=tag+':'+tardate
; 
   data = 0.5*(targPhot[0].data1+targPhot[1].data1)
   err  = targPhot[8].data1
   plot,wave,data, yr=1.2*[0,max(data[xw])], xtitle=xt,$
      title=title+'Raw Total A+B photometry (ADU/s/chan) '
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.RawTotalPhotometry.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif
;
   data = targPhot[5].data1
   err  = targPhot[11].data1
   plot,wave,data, yr=1.2*[0,max(data[xw])], xtitle=xt,$
      title=title+'Raw Masked sqrt(AB) photometry (ADU/s/chan) '
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.RawMaskedPhotometry.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif
;
   yr = [0,1.2*max(targVis.visamp[xw])]
   for i=0,n_elements(targVis)-1 do begin
      data = targVis[i].visamp
      err  = targVis[i].visamperr
      plot,wave,data,yr=yr, xtitle=xt,$
         title=title+'Raw Correlated Flux (ADU/s/channel)'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.RawCorrelatedFlux.dat',/GET_LUN
   for j=0, nxWave do printf,unit,wave[xw[j]], data[xw[j]], err[xw[j]]
   FREE_LUN,unit
endif
;
;     data = targVis[i].visphi
;     err  = targVis[i].visphierr
;     plot,wave,data,yr=180*[-1,1],xtitle=xt,title=title+'Raw Instrumental Phase'
;     errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
;if (doprint) then begin
;  openw,unit,title+'.RawInstrumentalPhase.dat',/GET_LUN
;  for j=0, nxWave do printf,unit,wave[xw[j]], data[xw[j]], err[xw[j]]
;  FREE_LUN,unit
;endif
   endfor

;instrumental visibility
   targInsVis = oirGetVis(tag+'.redcal.fits')
   yr = [0,1.2*max(targInsVis.visamp[xw])]
   yrd = [min(targInsVis.visphi[xw]), max(targInsVis.visphi[xw])]
   for i=0,n_elements(targInsVis)-1 do begin
      data = targInsVis[i].visamp
      err  = targInsVis[i].visamperr
      plot,wave,data,yr=yr, $
         xtitle=xt,title=title+' Instrumental Visibility '
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.InstrumentalVisibility.dat',/GET_LUN
   for j=0, nxWave do printf,unit,wave[xw[j]], data[xw[j]], err[xw[j]]
   FREE_LUN,unit
endif

      data = targInsVis[i].visphi
      err  = targInsVis[i].visphierr
      plot,wave,data , yr=yrd,xtitle=xt,title=title+' Instrumental Phase'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.InstrumentalPhase.dat',/GET_LUN
   for j=0, nxWave do printf,unit,wave[xw[j]], data[xw[j]], err[xw[j]]
   FREE_LUN,unit
endif
   endfor

;calibrated target values
   targVis  = oirGetVis(tag+'.calvis.fits')
   targPhot = oirGetData(tag+'.calphot.fits')

;calibrated visamp and phase
   yr = [0,1.2*max(targVis.visamp[xw])]
   yrd = [min(targVis.visphi[xw]), max(targVis.visphi[xw])]
   for i=0,n_elements(targVis)-1 do begin
      data = targVis[i].visamp
      err  = targVis[i].visamperr
      plot,wave,data,yr=yr, $
         xtitle=xt,title=title+' Calibrated Visibility '
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.CalibratedVisibility.dat',/GET_LUN
   for j=0, nxWave do printf,unit,wave[xw[j]], data[xw[j]], err[xw[j]]
   FREE_LUN,unit
endif

      data = targVis[i].visphi
      err  = targVis[i].visphierr
      plot,wave,data , yr=yrd,xtitle=xt,title=title+' Calibrated Phase'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.CalibratedPhase.dat',/GET_LUN
   for j=0, nxWave do printf,unit,wave[xw[j]], data[xw[j]], err[xw[j]]
   FREE_LUN,unit
endif
   endfor

;calibrated photometry, total and masked
   data = targPhot[0].data1
   err  = targPhot[2].data1
   yr = 1.2*max(data[xw])*[0,1]
   plot,wave,data, yr=yr, xtitle=xt, $
      title=title+' Calibrated Total Flux(Jy)'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.CalibratedTotalPhotometry.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif

;masked flux (Jy)

   data = targPhot[1].data1
   err  = targPhot[3].data1
   plot,wave,data, yr=yr,xtitle=xt, $
      title=title+' Calibrated Flux under Mask (Jy)'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.CalibratedMaskedPhotometry.dat',/GET_LUN
   for i=0, nxWave do printf,unit,wave[xw[i]], data[xw[i]], err[xw[i]]
   FREE_LUN,unit
endif

;correlated flux (Jy) = masked flux/visibility
   
   for i=0,n_elements(targVis)-1 do begin
      if (KEYWORD_SET(noPoint)) then begin
         data = targVis[i].visamp * targPhot[1].data1
         err = targVis[i].visamperr * targPhot[1].data1
      endif else begin
         data = targVis[i].visamp * targPhot[0].data1
         err = targVis[i].visamperr * targPhot[0].data1
      endelse
      plot,wave,data,yr=max(data[xw])*[0,1.2], $
         xtitle=xt,title=title+' Correlated Flux(Jy)'
      errPlot,wave[xer],data[xer]-err[xer],data[xer]+err[xer]
if (doprint) then begin
   openw,unit,title+'.CalibratedCorrelatedFlux.dat',/GET_LUN
   for j=0, nxWave do printf,unit,wave[xw[j]], data[xw[j]], err[xw[j]]
   FREE_LUN,unit

   openw,unit,title+'UVW.dat',/GET_LUN
   uvw = midifitsuvw(tag+'.fringes.fits', alt=alt)
   midiFieldAngle, tag+'.fringes.fits',para, phiN
   printf,unit,'UVW(meters) ',uvw, format='(a,2x,3f10.2)'
   printf,unit,'AirMass ',1./sin(alt/!radeg),format='(a, f10.2)'
   printf,unit,'North is ',180-phiN,' degrees counterclockwise from UP',$
      format='(a,2x,f10.2,2x,a)'
   FREE_LUN,unit
endif
   endfor

device,/close
set_plot,plotname
!p.multi = oldMulti
RETURN
END

PRO pwd
cd,current=c&print,c
RETURN
END
