;
; This file is part of MIA.
;
; MIA is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIA is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIA; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
FUNCTION vltiSubDir, dir, subdir
;produce a character string representation of a subdirectory
;of a directory or (by default) the current directory
;INPUTS:
;   dir     & string & primary directory.  If ommitted use current directory
;   subdir  & string & subdirectory to append, without any slashes
;RETURNS
;   concatendated full path of directory+slash+subdir
   if (N_PARAMS() EQ 1) then begin
      s = dir
      CD, current=d
   endif else begin
      s = subdir
      d = dir
   endelse
   if (!version.os_family EQ 'Windows') then slash='\' else slash='/'
RETURN, d+slash+s
END
