#!/bin/csh
#
# MIA/install.sh
#
# Last Change: Sun Oct 31 19:39:53 2004
#
# 1. make cfitsio-library:
#
echo "Compiling cfitsio ======================================================"
cd cfitsio
./configure
make clean
make
make install
cd ..
#
# 2. make miFitsTables-library
#
echo "Compiling miFitsTables ================================================="
cd miFitsTables/src/
make clean
make
cd ../..
#
# 3. make C-programs
#
echo "Compiling MIA-programs ================================================="
cd src

make clean
if (`uname` == 'SunOS') then
    make -k EXTRA_LIBS="-lsocket -lnsl"
else
    make -k
endif

make install
cd ..
#
# 4. create setup-file
#
echo "Creating MIAsetup-file ================================================="
if ( -e MIAsetup ) rm MIAsetup
sed -e "s,%HERE%,`pwd`," MIAsetup.in > MIAsetup
#
# Finished
#
set setup = `pwd`"/MIAsetup"

echo "All done ==============================================================="
echo ""
echo "To start MIA, type"
echo ""
echo "	idl $setup"
echo ""
echo "or start idl and then type"
echo ""
echo "	@$setup"
echo ""
echo "or set the variable IDL_STARTUP like this:"
echo ""
echo "	setenv IDL_STARTUP $setup"
echo ""
echo "and start idl."
echo "You can also add the setenv command to your .cshrc"
echo "to get MIA every time you start IDL."
echo ""
