/*
 * This file is part of MIA.
 *
 * MIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: OI_VIS.h,v 1.1 2003/07/29 12:52:02 jaffe Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jaffe     2003-07-25  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
/*----------------------------------------------------------------------- */
/* Definition of OI_VIS table                                      */
/*------------------------------------------------------------------------*/
/* types defined in #include "fitsio.h" */
    
/* table type */
char* extname="OI_VIS";
 
/* Define the keywords to be used */
int nkey = 4;       /* number of keywords */
char* keywords[] = { /* Table keywords */
         "REVISION",
         "DATE-OBS",
         "ARRNAME",
         "INSNAME"
};
int keytype[] = {   /* data types of the keywords */
         TINT,
         TSTRING,
         TSTRING,
         TSTRING
};
char* keycom[] = {   /* Description of the keywords */
         "Revision number of the table definition",
         "Observation Date",
         "Array Name",
         "Instrument/Disperser Name"
};
/* Define the  columns in the table */
int ncol = 12;       /* number of columns */
char* coltype[] = { /*  Column labels */
         "TARGET_ID",
         "TIME",
         "MJD",
         "INT_TIME",
         "VISAMP",
         "VISAMPERR",
         "VISPHI",
         "VISPHIERR",
         "UCOORD",
         "VCOORD",
         "STA_INDEX",
         "FLAG"
};
int coldatatype[] = {   /* data types of the keywords */
         TSHORT,
         TDOUBLE,
         TDOUBLE,
         TFLOAT,
         TFLOAT,
         TFLOAT,
         TFLOAT,
         TFLOAT,
         TDOUBLE,
         TDOUBLE,
         TSHORT,
         TSHORT
};
char* colunits[] = {   /*  Units for columns */
         "",
         "SECOND",
         "DAY",
         "SECOND",
         "",
         "",
         "DEGREE",
         "DEGREE",
         "METER",
         "METER",
         "",
         ""
};
long colcount[] = {   /*  Number of elements (as 1D) in the columns */
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         1,
         2,
         1
};
char* coldim[] = {   /*  Dimensionality if 2D or higher */
         " ",
         " ",
         " ",
         " ",
         " ",
         " ",
         " ",
         " ",
         " ",
         " ",
         " ",
         " "
};
/* */
