/*
 * This file is part of MIA.
 *
 * MIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: VLTIfileUtil.h,v 1.4 2002/05/08 21:24:47 jdejong Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jdejong 2002-05-08  imported
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
/* $Id: VLTIfileUtil.h,v 1.4 2002/05/08 21:24:47 jdejong Exp $ */

#ifndef _VLTIFILEUTIL_H
#define _VLTIFILEUTIL_H
/*----------------------------------------------------------------------- */
/* FITS file utility routines                                             */
/*----------------------------------------------------------------------- */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "VLTItable.h"

int append_tables(char *infile, char *outfile);
/*----------------------------------------------------------------------- */
/*  Append all tables from one file onto another.                         */
/*  This is done by copying all records following the primary HDU from    */
/*  the input to the output.                                              */
/*   Inputs:                                                              */
/*      infile    input file name                                         */
/*      outfile   output file name                                        */
/*   Returns:                                                             */
/*      0 on success, else error                                          */
/*----------------------------------------------------------------------- */

void copy_table(char *table_type, fitsfile *infptr, fitsfile *outfptr, 
		int *ierr);
/*----------------------------------------------------------------------- */
/*  Copy a specified table from one open FITS file to another             */
/*   Inputs:                                                              */
/*      table_type table type name                                        */
/*      infptr     input file cfitsio structure                           */
/*      outfptr    output file  cfitsio structure                         */
/*   Outputs:                                                             */
/*      ierr       Error code, 0 = OK, else failed, checked on input      */
/*----------------------------------------------------------------------- */

#endif /* end VLTIFILEUTIL_H */
/* */
