/*
 * This file is part of MIA.
 *
 * MIA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MIA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <math.h>
#include "fitsio.h"
#include "imaging_data.h"
#include "imaging_fdata.h"

#define TINY 1.e-20

void minrtsLudCmp(float *a, int n, int *indx, float *d) ;
void minrtsLubKsb(float *a, int n, int *indx, float *b) ;
void minrtsPolyFit(int order, int nData, float *xCoord, float *data, 
   float *weight, float *coeff) ;
char** oirStrSplit (char *string, int *nString) ;
void oirKillFileList(char **fileList, int nFiles) ;
void oirGetMaskImages(char *maskFileName, float *maskImages[], 
   int nRegion, int nxList[], int nyList[], int *ierr);
